#include "ConfigManager.h"

int ConfigManager::Init(VFileSystem* fs)
{
    this->fs = fs;
    return 0;
}

int ConfigManager::ReadId(String& id)
{
    uint8_t buf[MAX_ID_LEN + 1] = {0};
    int ret;
    if (ret = fs->ReadFile("/id.txt", buf, MAX_ID_LEN)) {
        return ret;
    }
    id = (char*)buf;
    return 0;
}

int ConfigManager::SetId(String id)
{
    int ret;
    if (id.length() > MAX_ID_LEN) {
        return -2;
    }
    if (ret = fs->WriteFile("/id.txt", (uint8_t*)(id.c_str()), id.length())) {
        return ret;
    }
    return 0;
}

int ConfigManager::ReadConfig(String& config)
{
    uint8_t buf[MAX_CONFIG_LEN + 1] = {0};
    int ret;
    if (ret = fs->ReadFile("/config.txt", buf, MAX_CONFIG_LEN)) {
        return ret;
    }
    config = (char*)buf;
    return 0;
}

int ConfigManager::WriteConfig(String config)
{
    int ret;
    if (config.length() > MAX_CONFIG_LEN) {
        return -2;
    }
    if (ret = fs->WriteFile("/config.txt", (uint8_t*)(config.c_str()), config.length())) {
        return ret;
    }
    return 0;
}
