#include <Arduino.h>
#include <vector>
#include <string>
#include "VFileSystem.h"
#include "ConfigManager.h"
#include "DataRecorder.h"
#include "InterSerial.h"
#include "UpperSerial.h"

VFileSystem fs;
ConfigManager cfg;
DataRecorder dataRec;
InterSerial interSerial;
UpperSerial upperSerial;

static void Halt()
{
    while (1) {
        delay(1000);
    }
}

void setup()
{
    if (fs.Init()) {
        Halt();
    }
    if (cfg.Init(&fs)) {
        Halt();
    }
    if (dataRec.Init(&fs)) {
        Halt();
    }
    interSerial.Init(&dataRec, &cfg);
    upperSerial.Init(&dataRec, &cfg);
}

void loop()
{
    interSerial.Process();
    delay(1);
    upperSerial.Process();
    delay(1);
}
